// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/extension -i Manager -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/extension"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements extension.Manager that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   extension.Manager
}

// AccessLoggingMiddleware instruments an implementation of the extension.Manager with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next extension.Manager) extension.Manager {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Action(ctx context.Context, in *extension.ActionRequest) (ap1 *extension.ActionResponse, err error) {
	begin := time.Now()

	m.logger.Debug("Action.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("in", in),
	)

	ap1, err = m.next.Action(ctx, in)

	m.logger.Debug("Action.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("ap1", ap1),
		zap.Error(err),
	)

	return ap1, err
}

func (m *accessLoggingMiddleware) Check(ctx context.Context, in *extension.CheckRequest) (err error) {
	begin := time.Now()

	m.logger.Debug("Check.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("in", in),
	)

	err = m.next.Check(ctx, in)

	m.logger.Debug("Check.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) GetDescriptor() (ep1 *extension.ExtensionDescriptor) {
	begin := time.Now()

	m.logger.Debug("GetDescriptor.Request")

	ep1 = m.next.GetDescriptor()

	m.logger.Debug("GetDescriptor.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("ep1", ep1),
	)

	return ep1
}

func (m *accessLoggingMiddleware) Install(ctx context.Context, in *extension.InstallRequest) (err error) {
	begin := time.Now()

	m.logger.Debug("Install.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("in", in),
	)

	err = m.next.Install(ctx, in)

	m.logger.Debug("Install.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) ListExtensions(ctx context.Context, space string, env string, filter *extension.ListExtensionsFilter) (ipa1 []*extension.Info, err error) {
	begin := time.Now()

	m.logger.Debug("ListExtensions.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("space", space),
		zap.Reflect("env", env),
		zap.Reflect("filter", filter),
	)

	ipa1, err = m.next.ListExtensions(ctx, space, env, filter)

	m.logger.Debug("ListExtensions.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("ipa1", ipa1),
		zap.Error(err),
	)

	return ipa1, err
}

func (m *accessLoggingMiddleware) ListRegisteredExtensions(ctx context.Context, extensions ...string) (epa1 []*extension.ExtensionConnector, err error) {
	begin := time.Now()

	m.logger.Debug("ListRegisteredExtensions.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("extensions", extensions),
	)

	epa1, err = m.next.ListRegisteredExtensions(ctx, extensions...)

	m.logger.Debug("ListRegisteredExtensions.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("epa1", epa1),
		zap.Error(err),
	)

	return epa1, err
}

func (m *accessLoggingMiddleware) RegisterExtensions(ctx context.Context, ext ...*extension.ExtensionConnector) (err error) {
	begin := time.Now()

	m.logger.Debug("RegisterExtensions.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("ext", ext),
	)

	err = m.next.RegisterExtensions(ctx, ext...)

	m.logger.Debug("RegisterExtensions.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Uninstall(ctx context.Context, in *extension.UninstallRequest) (err error) {
	begin := time.Now()

	m.logger.Debug("Uninstall.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("in", in),
	)

	err = m.next.Uninstall(ctx, in)

	m.logger.Debug("Uninstall.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) UnregisterExtensions(ctx context.Context, ext ...*extension.ExtensionConnector) (err error) {
	begin := time.Now()

	m.logger.Debug("UnregisterExtensions.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("ext", ext),
	)

	err = m.next.UnregisterExtensions(ctx, ext...)

	m.logger.Debug("UnregisterExtensions.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
